-- ============================================================================
-- == Cordial by Vansen on Moon Guard <vansen@gamemore.com>                  ==
-- == "Very special thanks to Judakha and his endless re-logging to test     ==
-- ==  this addon with nary a complaint."                                    ==
-- == Send automatic messages to guild chat for social events (achievements  ==
-- == logins, etc.) and automatically greets your friends on login.          ==
-- ============================================================================

local DEBUG = 3
local SEND_MESSAGES = true

Cordial = LibStub("AceAddon-3.0"):NewAddon("Cordial", "AceConsole-3.0", "AceEvent-3.0")
local L   = LibStub("AceLocale-3.0"):GetLocale("Cordial")
local GTempGratsIgnore = {}

-- ============================================================================

local options = {
	type = 'group',
	handler = Cordial,
	name = "Cordial",
	desc = "Configuration",
	order = 1,
	args = {
		Main = {
			type = 'group',
			name = "Main",
			desc = "Configuration",
			order = 1,
			guiInline = true,
			args = {
				--[[sectionGeneral = {
					type = "header",
					name = L["sectiongeneral"],
					
				},]]--
				mainDescription = {
					type = "description",
					name = L["maindesc"] .. "\n\n",
					order = 1,
				},
				enableCordial = {
					type = "toggle",
					name = L["enablecordial"],
					desc = L["enablecordialhelp"],
					get = "GetEnableCordial",
					set = "SetEnableCordial",
					--width = "full",
					order = 2,
				},
				messageDelayStart = {
					type = "range",
					name = L["messagedelaystart"],
					desc = L["messagedelaystarthelp"],
					min = 0,
					max = 20,
					step = 1,
					get = "GetMessageDelayStart",
					set = "SetMessageDelayStart",
					--width = "full",
					order = 5,
				},
				ignoreList = {
					type = "input",
					name = L["ignorelist"],
					desc = L["ignorelisthelp"],
					usage = L["ignorelistusage"],
					get = "GetIgnoreList",
					set = "SetIgnoreList",
					width = "full",
					order = 6,
				},
			},
		},
		Greetings = {
			name = "Greetings",
			handler = Cordial,
			type = 'group',
			guiInline = false,
			order = 2,
			args = {
				mainDescription = {
					type = "description",
					name = L["greetingsdesc"] .. "\n\n",
					order = 1,
				},
				messageWelcomeBackTime = {
					type = "range",
					name = L["messagewelcomebacktime"],
					desc = L["messagewelcomebacktimehelp"],
					min = 0,
					max = 60,
					step = 1,
					get = "GetWelcomeBackTime",
					set = "SetWelcomeBackTime",
					--width = "full",
					order = 18,
				},
				enableUseRealName = {
					type = "toggle",
					name = L["enableuserealname"],
					desc = L["enableuserealnamehelp"],
					get = "GetUseRealName",
					set = "SetUseRealName",
					--width = "full",
					order = 14,
				},
				welcomeBackList = {
					type = 'input',
					name = L["welcomebacklist"],
					desc = L["welcomebacklisthelp"],
					usage = L["welcomebacklistusage"],
					set = 'SetWelcomeBack',
					get = 'GetWelcomeBack',
					order = 18,
					width = "full",
				},
				--[[sectionGreetings = {
					type = "header",
					name = L["sectiongreetings"],
					order = 10,
				},]]--
				greetingList = {
					type = 'input',
					name = L["greetinglist"],
					desc = L["greetinglisthelp"],
					usage = L["greetinglistusage"],
					set = 'SetGreeting',
					get = 'GetGreeting',
					order = 17,
					width = "full",
				},
				enableGuildGreeting = {
					type = "toggle",
					name = L["enableguildgreeting"],
					desc = L["enableguildgreetinghelp"],
					get = "GetEnableGuildGreetings",
					set = "SetEnableGuildGreetings",
					width = "full",
					order = 11,
				},
				enableFriendGreeting = {
					type = "toggle",
					name = L["enablefriendgreeting"],
					desc = L["enablefriendgreetinghelp"],
					get = "GetEnableFriendGreetings",
					set = "SetEnableFriendGreetings",
					width = "full",
					order = 12,
				},
			},
		},
		Achievements = {
			name = "Achievements",
			handler = Cordial,
			type = 'group',
			guiInline = false,
			order = 10,
			args = {
				mainDescription = {
					type = "description",
					name = L["achievementsdesc"] .. "\n\n",
					order = 1,
				},
				--[[sectionGuildAchievement = {
					type = "header",
					name = L["sectionguildachievement"],
					order = 20,
				},]]--
				achievementList = {
					type = 'input',
					name = L["achievementlist"],
					desc = L["achievementlisthelp"],
					usage = L["achievementlistusage"],
					set = 'SetCongratulation',
					get = 'GetCongratulation',
					order = 21,
					width = "full",
				},
				enableAchievementCongratulations = {
					type = "toggle",
					name = L["enableachievementcongratulations"],
					desc = L["enableachievementcongratulationshelp"],
					get = "GetEnableAchievementCongratulations",
					set = "SetEnableAchievementCongratulations",
					width = "full",
					order = 21,
				},
			},
		},
		Advanced = {
			name = "Advanced",
			handler = Cordial,
			type = 'group',
			guiInline = false,
			order = 10,
			args = {
				mainDescription = {
					type = "description",
					name = L["advanceddesc"] .. "\n\n",
					order = 1,
				},
				--[[sectionAdvancedHeader = {
					type = "header",
					name = L["advancedheader"],
					order = 2,
				},]]--
				allcontacts = {
					type = "input",
					name = L["nicknames"],
					desc = L["nicknameshelp"],
					usage = L["nicknamesusage"],
					get = "GetNicknameList",
					set = "SetNicknameList",
					multiline = true,
					width="full",
					order = 5,
				},
			},
		},
	},
}

-- ============================================================================

local defaults = {
	profile = {
		greetingList = L["greetinglistdefault"],
		congratulationList = L["congratulationlistdefault"],
		welcomeBackList = L["welcomebacklistdefault"],
		nicknameList = L["nicknamelist"],
		nicknameTable = {},
		ignoreList = "",
		showInChat = true,
		enableGuildGreetings = false,
		enableFriendGreetings = true,
		enableAchievementCongratulations = true,
		messageDelayStart = 10,
		messageDelayEnd = 20,
		enabled = true,
		userealname = false,
		awayTime = {},
		welcomeBackTime = 30,
	},
}

-- ============================================================================

function Cordial:SetEnableCordial(info, newValue)
	self.db.profile.enabled = newValue

	if newValue then
		Cordial:Enable()
	else
		Cordial:Disable()
	end
end
function Cordial:GetEnableCordial(info)
	return self.db.profile.enabled
end

function Cordial:SetWelcomeBack(info, newValue)
	self.db.profile.welcomeBackList = newValue
end
function Cordial:GetWelcomeBack(info)
	return self.db.profile.welcomeBackList
end

function Cordial:SetNicknameList(info, newValue)
	self.db.profile.nicknameTable = {}
	local a = string.split(newValue, ";")
	for k,v in pairs(a) do
		local b = string.split(v, "=")
		local tl = string.split(b[1], ",")
		
		for k2,v2 in pairs(string.split(b[1], ",")) do
			self.db.profile.nicknameTable[string.lower(v2)] = b[2]
		end
	end
	self.db.profile.nicknameList = newValue
end
function Cordial:GetNicknameList(info)
	return self.db.profile.nicknameList
end

function Cordial:SetWelcomeBackTime(info, newValue)
	self.db.profile.welcomeBackTime = newValue
end
function Cordial:GetWelcomeBackTime(info)
	return self.db.profile.welcomeBackTime
end

function Cordial:SetUseRealName(info, newValue)
	self.db.profile.userealname = newValue
end
function Cordial:GetUseRealName(info)
	return self.db.profile.userealname
end

function Cordial:SetGreeting(info, newValue)
	self.db.profile.greetingList = newValue
end
function Cordial:GetGreeting(info)
	return self.db.profile.greetingList
end

function Cordial:SetCongratulation(info, newValue)
	self.db.profile.congratulationList = newValue
end
function Cordial:GetCongratulation(info)
	return self.db.profile.congratulationList
end

function Cordial:SetIgnoreList(info, newValue)
	self.db.profile.ignoreList = newValue
end
function Cordial:GetIgnoreList(info)
	return self.db.profile.ignoreList
end

function Cordial:SetShowInChat(info, newValue)
	self.db.profile.showInChat = newValue
end
function Cordial:GetShowInChat(info)
	return self.db.profile.showInChat
end

function Cordial:SetEnableGuildGreetings(info, newValue)
	self.db.profile.enableGuildGreetings = newValue
end
function Cordial:GetEnableGuildGreetings(info)
	return self.db.profile.enableGuildGreetings
end

function Cordial:SetEnableFriendGreetings(info, newValue)
	self.db.profile.enableFriendGreetings = newValue
end
function Cordial:GetEnableFriendGreetings(info)
	return self.db.profile.enableFriendGreetings
end

function Cordial:SetEnableFriendGreetings(info, newValue)
	self.db.profile.enableFriendGreetings = newValue
end
function Cordial:GetEnableFriendGreetings(info)
	return self.db.profile.enableFriendGreetings
end

function Cordial:SetEnableAchievementCongratulations(info, newValue)
	self.db.profile.enableAchievementCongratulations = newValue
end
function Cordial:GetEnableAchievementCongratulations(info)
	return self.db.profile.enableAchievementCongratulations
end

function Cordial:SetMessageDelayStart(info, newValue)
	self.db.profile.messageDelayStart = newValue
	self.db.profile.messageDelayEnd = newValue * 2
end
function Cordial:GetMessageDelayStart(info)
	return self.db.profile.messageDelayStart
end

function Cordial:GetMessageDelayEnd(info)
	return self.db.profile.messageDelayEnd
end

function Cordial:SetAwayTime(name)
	local a = Cordial:GetAwayTime()
	a[name] = time()
	self.db.profile.awayTime = a
	-- Cordial:PrintDebug("Setting away time for " .. name, 2)
end
function Cordial:GetAwayTime()
	return self.db.profile.awayTime
end

-- ============================================================================

function Cordial:ChatCommand(input)
	if not input or input:trim() == "" then
		InterfaceOptionsFrame_OpenToCategory(self.optionsFrame.Main)
	else
		LibStub("AceConfigCmd-3.0").HandleCommand(Cordial, "cordial", "options")
	end
end

-- ============================================================================

function Cordial:OnInitialize()
	-- Cordial:PrintDebug("OnInitialize function", 3)
	local ACD = LibStub("AceConfigDialog-3.0")
	local AC = LibStub("AceConfig-3.0")
	self.db = LibStub("AceDB-3.0"):New("CordialDB", defaults, "Default")
	self.optionsFrame = {}
	options.args.profile = LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db)
	
	AC:RegisterOptionsTable("Cordial", options, "cordial")
	AC:RegisterOptionsTable("Profiles", options.args.profile, "Profiles")
	self.optionsFrame.Main = ACD:AddToBlizOptions("Cordial", nil, nil, "Main")
	self.optionsFrame.Greetings = ACD:AddToBlizOptions("Cordial", "Greetings", "Cordial", "Greetings")
	self.optionsFrame.Achievements = ACD:AddToBlizOptions("Cordial", "Achievements", "Cordial", "Achievements")
	self.optionsFrame.Advanced = ACD:AddToBlizOptions("Cordial", "Advanced", "Cordial", "Advanced")
	self.optionsFrame.Profiles = ACD:AddToBlizOptions("Profiles", "Profiles", "Cordial")
	
	self:RegisterChatCommand("cordial", "ChatCommand")
	
	Cordial:CleanAwayTimeStorage()
end

function Cordial:OnEnable()
	-- Cordial:PrintDebug("OnEnable function", 3)
	if not Cordial:GetEnableCordial() then
		Cordial:Disable()
	else
		self:RegisterEvent("GUILD_ROSTER_UPDATE")
		self:RegisterEvent("BN_FRIEND_ACCOUNT_ONLINE")
		self:RegisterEvent("BN_FRIEND_ACCOUNT_OFFLINE")
		self:RegisterEvent("CHAT_MSG_GUILD_ACHIEVEMENT")
		self:RegisterEvent("CHAT_MSG_SYSTEM")
		
		local message = L["enabledmessage"]
		
		if Cordial:GetEnableGuildGreetings() then
			message = message .. " " .. L["enabledmessageguild"]
		end
		
		if Cordial:GetUseRealName() then
			message = message .. " " .. L["enabledmessagerealid"]
		end
		
		self:Print(message)
	end
end

function Cordial:OnDisable()
	-- Cordial:PrintDebug("OnDisable function", 3)
	if Cordial:GetEnableCordial() then
		Cordial:Enable()
	else
		self:UnregisterEvent("GUILD_ROSTER_UPDATE")
		self:UnregisterEvent("BN_FRIEND_ACCOUNT_ONLINE")
		self:UnregisterEvent("BN_FRIEND_ACCOUNT_OFFLINE")
		self:UnregisterEvent("CHAT_MSG_GUILD_ACHIEVEMENT")
		self:UnregisterEvent("CHAT_MSG_SYSTEM")
		self:Print(L["disabledmessage"])
	end
end

function Cordial:RefreshConfig()
end

-- ============================================================================

function Cordial:GUILD_ROSTER_UPDATE()
end

function Cordial:BN_FRIEND_ACCOUNT_ONLINE(e, number)
	-- Cordial:PrintDebug("BN_FRIEND_ACCOUNT_ONLINE function", 3)
	local presenceID, givenName, surname, toonName, toonID, client, isOnline, lastOnline, isAFK, isDND, messageText, noteText = BNGetFriendInfoByID(number);

	local toonName = toonName
	local fullname = string.format(BATTLENET_NAME_FORMAT, givenName, surname)
	
	-- Cordial:PrintDebug(fullname.." has logged on "..toonName..".", 2);
	
	if not self:IsIgnoredName(toonName) and (not Cordial:IsGuildName(toonName) or not Cordial:GetEnableGuildGreetings()) then
		recipient = {fullname, toonName, givenName, presenceID}
		LibStub("AceTimer-3.0"):ScheduleTimer(Cordial.BNetFriendWhisper, Cordial:GetRandomDelay(), recipient)
	end
end

function Cordial:BN_FRIEND_ACCOUNT_OFFLINE(e, number)
	-- Cordial:PrintDebug("BN_FRIEND_ACCOUNT_OFFLINE function", 3)
	Cordial:SetAwayTime(number)
end

function Cordial:CHAT_MSG_GUILD_ACHIEVEMENT(e, msg, name)
	-- Cordial:PrintDebug("CHAT_MSG_GUILD_ACHIEVEMENT function", 3)
	local seconds = Cordial:GetRandomDelay()

	if not self:IsIgnoredName(name) and not GTempGratsIgnore[name] then
		name = Cordial:GetNickname(name)
		-- Cordial:PrintDebug("Saying congrats to " .. name, 2)
		GTempGratsIgnore[name] = name
		LibStub("AceTimer-3.0"):ScheduleTimer(Cordial.GuildCongratulations, seconds, name)
	end
end

function Cordial:CHAT_MSG_SYSTEM(e, msg)
	-- Cordial:PrintDebug("CHAT_MSG_SYSTEM function", 3)
	local name = nil

	if string.match(msg, "^.*%[.*%].* has come online.") then
		name = string.match(msg, "^.*%[(.*)%].* has come online.")
		-- Cordial:PrintDebug(name .. " has come online", 2)
		Cordial:SendGreeting(name)
	elseif string.match(msg, "^.* has joined the guild.") then
		name = string.match(msg, "^(.*) has joined the guild.")
		-- Cordial:PrintDebug(name .. " has joined the guild.", 2)
		--Cordial:SendGreeting(name)
		--Below is a quick fix for a problem to look into later. With a brand new member, it doesn't
		--  think that person is a guild member. I think it has to do with guild info requests
		--  being throttled by 10 seconds.
		local seconds = Cordial:GetRandomDelay()
		LibStub("AceTimer-3.0"):ScheduleTimer(Cordial.GuildGreeting, seconds, name)
	elseif string.match(msg, "^.* has gone offline.") then
		name = string.match(msg, "^(.*) has gone offline.")
		name = Cordial:GetNickname(name)
		-- Cordial:PrintDebug(name .. " has gone offline", 2)
		Cordial:SetAwayTime(name)
	elseif string.match(msg, "^.*%[.*%].* has gone offline.") then
		name = string.match(msg, "^.*%[(.*)%].* has gone offline.")
		name = Cordial:GetNickname(name)
		-- Cordial:PrintDebug(name .. " has gone offline", 2)
		Cordial:SetAwayTime(name)
	end
end

-- ============================================================================

function Cordial:CleanAwayTimeStorage()
	for k,v in pairs(Cordial:GetAwayTime()) do 
		if Cordial:GetAwayTime()[k] + 3601 <= time() then
			-- Cordial:PrintDebug(k .. " has been gone more than an hour. Trim.", 2)
			self.db.profile.awayTime[k] = nil
		else
			-- Cordial:PrintDebug(k .. " has been gone less than an hour. Keep.", 2)
		end
	end
end

function Cordial:SendGreeting(name)
	-- Cordial:PrintDebug("SendGreeting function", 3)
	if name and not self:IsIgnoredName(name) then
		-- Cordial:PrintDebug("Saying hi to " .. name, 2)
		local seconds = Cordial:GetRandomDelay()
		if self:IsGuildName(name) and Cordial:GetEnableGuildGreetings() then
			-- Cordial:PrintDebug("Sending guild greeting in " .. seconds .. " seconds", 2)
			LibStub("AceTimer-3.0"):ScheduleTimer(Cordial.GuildGreeting, seconds, name)
		elseif self:IsFriendName(name) and Cordial:GetEnableFriendGreetings() then
			-- Cordial:PrintDebug("Sending whisper greeting in " .. seconds .. " seconds", 2)
			LibStub("AceTimer-3.0"):ScheduleTimer(Cordial.FriendWhisper, seconds, name)
		end
		
		if not Cordial:GetEnableGuildGreetings() and not Cordial:GetEnableFriendGreetings() then
			-- Cordial:PrintDebug("Guild and friend greetings turned off. No message sent.", 2)
		end
	end
end

function Cordial:SendWelcomeBack(name)
	-- Cordial:PrintDebug("SendWelcomeBack function", 3)
	if name and not self:IsIgnoredName(name) then
		-- Cordial:PrintDebug("Saying welcome back to " .. name, 2)
		local seconds = Cordial:GetRandomDelay()
		if Cordial:IsGuildName(name) and Cordial:GetEnableGuildGreetings() then
			-- Cordial:PrintDebug("Sending guild welcome back in " .. seconds .. " seconds", 2)
			LibStub("AceTimer-3.0"):ScheduleTimer(Cordial.GuildGreeting, seconds, name)
		elseif self:IsFriendName(name) and Cordial:GetEnableFriendGreetings() then
			-- Cordial:PrintDebug("Sending whisper welcome back in " .. seconds .. " seconds", 2)
			LibStub("AceTimer-3.0"):ScheduleTimer(Cordial.FriendWhisper, seconds, name)
		end
	end
end

function Cordial:IsIgnoredName(name)
	-- Cordial:PrintDebug("IsIgnoredName function", 3)
	
	if string.find(self:GetIgnoreList(), name) or string.find(self:GetIgnoreList(), Cordial:GetNickname(name)) then
		Cordial:Print("Ignoring " .. name)
		return true
	else
		-- Cordial:PrintDebug("Not ignoring " .. name, 1)
		return false
	end
end

function Cordial:IsGuildName(sname)
	-- Cordial:PrintDebug("IsGuildName function", 3)
	for index = 1, GetNumGuildMembers() do
		local name, rank, rankIndex, level, class, zone, note, officernote, online, status, classFileName, achievementPoints, achievementRank, isMobile = GetGuildRosterInfo(index)
		if sname == name then
			-- Cordial:PrintDebug(sname .. " is a guild member", 2)
			return true
		end
	end

	-- Cordial:PrintDebug(sname .. " is not a guild member", 2)
	return false
end

function Cordial:IsFriendName(sname)
	-- Cordial:PrintDebug("IsFriendName function", 3)
	for index = 1, GetNumFriends() do
		local name, level, class, area, connected, status, note, RAF = GetFriendInfo(index)
		if sname == name then
			-- Cordial:PrintDebug(sname .. " is a friend", 2)
			return true
		end
	end

	-- Cordial:PrintDebug(sname .. " is not a friend", 2)
	return false
end

function Cordial:IsBNetFriendName(sname)
	-- Cordial:PrintDebug("IsBNetFriendName function", 3)
	for index = 1, BNGetNumFriends() do
		presenceID, givenName, surname, toonName, toonID, client, isOnline, lastOnline, isAFK, isDND, messageText, noteText, isFriend, unknown = BNGetFriendInfo(index)
		
		-- Cordial:PrintDebug("Searching: " .. toonName, 2)
		
		if sname == toonName then
			-- Cordial:PrintDebug(sname .. " is a BNet friend (" .. toonName ..")", 2)
			return true
		end
	end

	-- Cordial:PrintDebug(sname .. " is not a BNet friend.", 2)
	return false
end

function Cordial:doTest()
	-- Cordial:PrintDebug("doTest function", 3)
	LibStub("AceTimer-3.0"):ScheduleTimer(Cordial.GuildGreeting, Cordial:GetRandomDelay(), "Test")
end

function Cordial:GetRandomDelay()
	-- Cordial:PrintDebug("GetRandomDelay function", 3)
	return random(Cordial:GetMessageDelayStart(), Cordial:GetMessageDelayEnd())
end

function Cordial.GuildGreeting(name)
	-- Cordial:PrintDebug("GuildGreeting function", 3)
	if name and Cordial:GetEnableGuildGreetings() then
		name = Cordial:GetNickname(name)
		greeting = Cordial:GetProperGreeting(name)
		message = string.gsub(greeting, "@", Cordial:GetNickname(name))
		-- Cordial:PrintDebug("Guild Message: " .. message, 1)
		if SEND_MESSAGES then SendChatMessage(message, GUILD) end
	end
end

function Cordial.FriendWhisper(name)
	-- Cordial:PrintDebug("FriendWhisper function", 3)
	-- Prevent a double whisper to someone who's both a friend and bnet friend
	if name and not Cordial:IsBNetFriendName(name) and Cordial:GetEnableFriendGreetings() then
		nickname = Cordial:GetNickname(name)
		greeting = Cordial:GetProperGreeting(name)
		message = string.gsub(greeting, "@", Cordial:GetNickname(nickname))
		-- Cordial:PrintDebug("Whisper Message to " .. name .. ": " .. message, 1)
		if SEND_MESSAGES then SendChatMessage(message, WHISPER, "Common", name) end
	end
end

function Cordial.BNetFriendWhisper(recipient)
	-- Cordial:PrintDebug("BNetFriendWhisper function", 3)
	local fname = recipient[1] -- Full name won't work due to Blizzard's security controls. I'm leaving it here, however, incase things "magically" change.
	local tname = recipient[2]
	local gname = recipient[3]
	local id = recipient[4]
	local fnamenick = Cordial:GetNickname(fname)
	local gnamenick = Cordial:GetNickname(gname)
	local tnamenick = Cordial:GetNickname(tname)
		
	if Cordial:GetUseRealName() then
		-- Cordial:PrintDebug("Using real name", 2)
		name = gname
	elseif fnamenick ~= fname then
		-- Cordial:PrintDebug("**USING FULL NAME NICKNAME", 2)
		name = fnamenick
	elseif Cordial:GetNickname(gname) ~= gname then
		-- Cordial:PrintDebug("**USING GIVEN NAME NICKNAME", 2)
		name = gnamenick
	else
		-- Cordial:PrintDebug("**USING TOON NAME NICKNAME", 2)
		name = tnamenick
	end
	
	if name and Cordial:GetEnableFriendGreetings() then
		greeting = Cordial:GetProperGreeting(id)
		message = string.gsub(greeting, "@", name)
		-- Cordial:PrintDebug("Whisper BNet Message to " .. name .. " (" .. id .. "): " .. message, 1)
		if SEND_MESSAGES then BNSendWhisper(id, message) end
	end
end

function Cordial:GetNickname(name)
	-- Cordial:PrintDebug("GetNickname function", 3)
	
	-- Cordial:PrintDebug("Getting nickname for '" .. name .. "'", 2)
	local nickname = self.db.profile.nicknameTable[string.lower(name)]
	if nickname then
		-- Cordial:PrintDebug(name .. " has nickname of " .. nickname, 2)
		return nickname
	end
	-- Cordial:PrintDebug(name .. " has no nickname", 2)
	return name
end

function Cordial:GetProperGreeting(name)
	-- Cordial:PrintDebug("GetProperGreeting function", 3)
	awaytime = Cordial:GetAwayTime()[name]
	if awaytime then
		if awaytime + (Cordial:GetWelcomeBackTime() * 60) > time() then
			-- Cordial:PrintDebug(name .. " will be welcomed back", 2)
			return Cordial:GetRandomWelcomeBack()
		end
	end

	return Cordial:GetRandomGreeting()
end

function Cordial.GuildCongratulations(name)
	-- Cordial:PrintDebug("GuildCongratulations function", 3)
	if Cordial:GetEnableAchievementCongratulations() and name ~= nil and name ~= GetUnitName("player") then
		greeting = Cordial:GetRandomCongratulation()
		message = string.gsub(greeting, "@", name)
		-- Cordial:PrintDebug("Guild Congratulations: " .. message, 1)
		if SEND_MESSAGES then SendChatMessage(message, GUILD) end
		GTempGratsIgnore[name] = nil
	end
end

function Cordial:GetRandomGreeting()
	-- Cordial:PrintDebug("GetRandomGreeting function", 3)
	local greetings = string.split(Cordial:GetGreeting(), ";")
	local size = table.getn(greetings)
	local greeting = ""
	local count = 0

	-- Incase users enter a bad string I want to try hard to get their message out
	while string.len(greeting) == 0 do
		greeting = greetings[random(1,size)]
		if count >= size then
			self:Print(L["greetingmessageerror"])
			greeting = "Hi @"
			break
		end
		count = count + 1
	end
	-- Cordial:PrintDebug("Geetings searched " .. count .. " times", 2)
	return greeting
end

function Cordial:GetRandomWelcomeBack()
	-- Cordial:PrintDebug("GetRandomWelcomeBack function", 3)
	local greetings = string.split(Cordial:GetWelcomeBack(), ";")
	local size = table.getn(greetings)
	local greeting = ""
	local count = 0

	-- Incase users enter a bad string I want to try hard to get their message out
	while string.len(greeting) == 0 do
		greeting = greetings[random(1,size)]
		if count >= size then
			self:Print(L["welcomebackmessageerror"])
			greeting = "wb @"
			break
		end
		count = count + 1
	end
	-- Cordial:PrintDebug("Welcome backs searched " .. count .. " times", 2)
	return greeting
end

function Cordial:GetRandomCongratulation()
	-- Cordial:PrintDebug("GetRandomCongratulation function", 3)
	local congratulations = string.split(Cordial:GetCongratulation(), ";")
	local size = table.getn(congratulations)
	local congratulation = ""
	local count = 0

	-- Incase users enter a bad string I want to try hard to get their message out
	while string.len(congratulation) == 0 do
		congratulation = congratulations[random(1,size)]
		if count >= size then
			self:Print(L["congratulationsmessageerror"])
			congratulation = "Congrats @!"
			break
		end
		count = count + 1
	end
	-- Cordial:PrintDebug("Congratulations searched " .. count .. " times", 2)
	return congratulation
end

-- ============================================================================

function Cordial:PrintDebug(msg, level)
	if level <= DEBUG then
		self:Print(msg)
	end
end

function Cordial:IsInList(s, l)
	for _,v in pairs(l) do
		if v == s then
			return true
		end
	end
end

function string:split(delimiter)
	local result = {}
	local from  = 1
	local delim_from, delim_to = string.find( self, delimiter, from )
	while delim_from do
		table.insert( result, string.sub(self, from, delim_from-1):trim())
		from  = delim_to + 1
		delim_from, delim_to = string.find( self, delimiter, from)
	end
	table.insert(result, string.sub(self, from):trim())
	return result
end